/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { DisciplineDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { DisciplineDtoResponse } from '../../@coscine/model';
/**
 * DisciplineApi - axios parameter creator
 * @export
 */
export const DisciplineApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2DisciplinesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/disciplines`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a discipline with the specified ID.
         * @param {string} disciplineId The ID of the discipline.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDiscipline: async (disciplineId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'disciplineId' is not null or undefined
            assertParamExists('getDiscipline', 'disciplineId', disciplineId)
            const localVarPath = `/api/v2/disciplines/{disciplineId}`
                .replace(`{${"disciplineId"}}`, encodeURIComponent(String(disciplineId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all disciplines.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDisciplines: async (pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/disciplines`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DisciplineApi - functional programming interface
 * @export
 */
export const DisciplineApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DisciplineApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2DisciplinesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2DisciplinesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['DisciplineApi.apiV2DisciplinesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a discipline with the specified ID.
         * @param {string} disciplineId The ID of the discipline.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getDiscipline(disciplineId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DisciplineDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getDiscipline(disciplineId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['DisciplineApi.getDiscipline']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all disciplines.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getDisciplines(pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DisciplineDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getDisciplines(pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['DisciplineApi.getDisciplines']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * DisciplineApi - factory interface
 * @export
 */
export const DisciplineApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DisciplineApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2DisciplinesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2DisciplinesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a discipline with the specified ID.
         * @param {DisciplineApiGetDisciplineRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDiscipline(requestParameters: DisciplineApiGetDisciplineRequest, options?: RawAxiosRequestConfig): AxiosPromise<DisciplineDtoResponse> {
            return localVarFp.getDiscipline(requestParameters.disciplineId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all disciplines.
         * @param {DisciplineApiGetDisciplinesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDisciplines(requestParameters: DisciplineApiGetDisciplinesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<DisciplineDtoPagedResponse> {
            return localVarFp.getDisciplines(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getDiscipline operation in DisciplineApi.
 * @export
 * @interface DisciplineApiGetDisciplineRequest
 */
export interface DisciplineApiGetDisciplineRequest {
    /**
     * The ID of the discipline.
     * @type {string}
     * @memberof DisciplineApiGetDiscipline
     */
    readonly disciplineId: string
}

/**
 * Request parameters for getDisciplines operation in DisciplineApi.
 * @export
 * @interface DisciplineApiGetDisciplinesRequest
 */
export interface DisciplineApiGetDisciplinesRequest {
    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof DisciplineApiGetDisciplines
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof DisciplineApiGetDisciplines
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof DisciplineApiGetDisciplines
     */
    readonly orderBy?: string
}

/**
 * DisciplineApi - object-oriented interface
 * @export
 * @class DisciplineApi
 * @extends {BaseAPI}
 */
export class DisciplineApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DisciplineApi
     */
    public apiV2DisciplinesOptions(options?: RawAxiosRequestConfig) {
        return DisciplineApiFp(this.configuration).apiV2DisciplinesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a discipline with the specified ID.
     * @param {DisciplineApiGetDisciplineRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DisciplineApi
     */
    public getDiscipline(requestParameters: DisciplineApiGetDisciplineRequest, options?: RawAxiosRequestConfig) {
        return DisciplineApiFp(this.configuration).getDiscipline(requestParameters.disciplineId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all disciplines.
     * @param {DisciplineApiGetDisciplinesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DisciplineApi
     */
    public getDisciplines(requestParameters: DisciplineApiGetDisciplinesRequest = {}, options?: RawAxiosRequestConfig) {
        return DisciplineApiFp(this.configuration).getDisciplines(requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }
}

